# Documentation string. I wonder what ever refers to it? 

__doc__ = """Speedtest product module.

This module provides the methods and classes that Zope needs for the product. 
__init__.py is responsible for registering these methods and classes.

See README.txt for more details."""

# Version string. Usually updated automatically by CVS. 

__version__ = '0.3' # I used to wonder whether Zope checked these. Nope. 

# Now, you can compress these imports down to three lines, but that makes it 
# harder to document it as you go. Here's the long-winded version: 

from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import DTMLFile
from Globals import MessageDialog # provid
from Globals import Persistent    # makes an object stick in the ZODB
from STEntry import STEntry

import OFS.SimpleItem
import Acquisition
import AccessControl.Role

servernotice_html = HTMLFile('servernotice', globals())
speedtestfile = HTMLFile('speedtestfile', globals()) 		 
manage_addSpeedtestForm = DTMLFile('speedtestAdd', globals()) 

def manage_addSpeedtest(self, id,title='', body_html='', serveraware='' ,REQUEST=None):
    """Add a Speedtest to a folder."""    
    self._setObject(id, Speedtest(id, title,body_html,serveraware))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)
	

class Speedtest(
    OFS.SimpleItem.Item,   # A simple Principia object. Not Folderish. 
    Persistent,            # Make us persistent. Yaah! 
    Acquisition.Implicit,  # Uh, whatever. 
    AccessControl.Role.RoleManager # Security manager.     
    
    ): 
    """Speedtest object. 
    
    This is an attempt at writing a product from scratch using mostly 
    Python instead of ZClasses. We'll see how it all goes.
    """
            
    meta_type = 'Speedtest' # what do people think they're adding? 

    manage_options = ( # what management options are there?
	{'label': 'Edit',       'action': 'manage_main'},
	{'label': 'View',       'action': ''}, # defaults to index_html
	{'label': 'Result',     'action': 'manage_result'}, # defaults to index_html
	{'label': 'Security',   'action': 'manage_access'},
        {'label': 'About ',   'action': 'manage_about'}
	) 

    __ac_permissions__=( # what permissions make sense for us? 
	('View management screens', ('manage_tabs','manage_main')),
	('Change permissions',      ('manage_access',)           ),
	('Change Speedtest'     ,     ('manage_edit',)             ),
	('View Result'     ,        ('manage_result',)             ),
	('View Speedtest',            ('',)                        ),
	)

    def __init__(self, id, title='', body_html='', serveraware='' ): 
        """initialise a new instance of Speedtest"""
        self.id = id
	self.title = title	
	self.body_html = body_html
	self.serveraware = serveraware    
	self.servernotice_html = DTMLFile('servernotice', globals()) # client side getherer of info
	self.entries = {}
	self.lastentryID = 1
    speedtestfile = HTMLFile('speedtestfile', globals()) 		 
    index_html = DTMLFile('index', globals()) # View Interface
    manage_about = HTMLFile('SpeedtestAbout', globals())         
    header_speedtest = HTMLFile('SpeedtestHeader', globals())         
    manage_main = HTMLFile('speedtestEdit', globals()) # Management Interface
    manage_result = DTMLFile('SpeedtestResult', globals())         
    manage_remove = DTMLFile('SpeedtestRemove', globals())         	
    
        
    	
    def addentry(self, idst = "", filesize = "" , txtime = "", txest = "", ipaddr = "", xuser = "" ,REQUEST = None):
          "Method to Add Speed Test Results"
    	  id= self.lastentryID = self.lastentryID + 1
    	  id= str(id)	    
    	  entry = STEntry(id, idst, filesize,txtime,txest,ipaddr,xuser)
    	  self.entries[id] = entry
    	  #self.__changed__(1)
	  
    	  #if REQUEST is not None:
    	  # return self.manage_result(self,REQUEST)
    
    def listentry(self):
        "method to list"
    	return self.entries.values()

    def delentries(self, REQUEST = None):
        "remove all of list"	
	self.entries = [] 
	self.entries = {}
	self.lastentryID = 1
	return self.entries.values()
			
    
    def manage_edit(self, title, body_html,serveraware,REQUEST=None): 
        """does this really need a doc string?"""
	self.title = title	
	self.body_html = body_html
	self.serveraware = serveraware
	if REQUEST is not None:
	    return MessageDialog(
		title = 'Edited',
		message = "Properties for %s changed." % self.id,
		action = './manage_main',
		)
